
extern LCK **lck_tab;

extern ENTRY **buk_tab;

extern ENTRY **ent_tab;

extern long num_ents_ct;

extern int num_buks;

extern int blk_size;

extern unsigned char *empty_blk;

extern LCK *empty_blk_lck;

extern int cache_ent_enable;

int ent_write(ENTRY *ent)	;

extern int flush_ent_cntr;

extern LCK *flush_ent_lck;

int ents_flush(long trynum,long flushnum)	;

int ent_flush_P(ENTRY *tent)	;

void release_ent(ENTRY *ent,int acctype)	;

int ent_update_access(ENTRY *ent,int old_acctype,int new_acctype)	;

extern int free_buk_cntr;

extern LCK *free_ent_lck;

extern ENTRY *free_ents;

ENTRY *get_free_free_ent(void)	;

void splice_out_ent(int seg,long blk_num,ENTRY *buk,ENTRY *ent)	;

void recycle_ent(ENTRY *ent)	;

ENTRY *select_idle_ent(int lseg,long lblk_num)	;

ENTRY *reclaim_ent(ENTRY *ent,int lseg,long lblk_num)	;

ENTRY *try_get_free_ent(int lseg,long lblk_num)	;

ENTRY *allocate_ent(void)	;

void ent_copy(ENTRY *to_ent,ENTRY *from_ent)	;

int get_ent_copy(ENTRY *to_ent,int seg,long blk_num)	;

int write_ent_copy(ENTRY *ent)	;

void flush_flc(int seg,int fullness)	;

int initload_flc_P(int seg)	;

int blk_free(ENTRY *ent)	;

int flc_fill(int seg)	;

int flc_proc(unsigned char *keystr,int klen,unsigned char *vstr,int vlen,long *long_ara)	;

ENTRY *create_new_blk_ent(int seg)	;

ENTRY *try_get_ent(int seg,long blk_num,int acctype)	;

ENTRY *chain_find_ent(HAND *han,int acctype,unsigned char *key_str,int k_len,int *pkt)	;

ENTRY *chain_find_prev_ent(HAND *han,int acctype,unsigned char *key_str,int k_len,int *pkt)	;

ENTRY *get_ent(int seg,long blk_num,int acctype)	;

ENTRY *switch_ent(ENTRY *old_ent,int oldacc,long new_num,int newacc)	;

int init_wb(long max_num_ents_ct,int max_num_buks,int max_blk_size)	;

int final_wb(void)	;

void check_blk(unsigned char *blk)	;

void check_key_order(unsigned char *blk)	;

int do_seg_buffers(int seg,int_function func)	;

int check_buffer(ENTRY *ent)	;

void check_access(void)	;

int flush_buffer(ENTRY *ent)	;

int purge_buffer(ENTRY *ent)	;
